# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class HttpRequestPart(str, enum.Enum):
    """
    Refer to part of the request.
    """

    BODY = "BODY"
    HEADER = "HEADER"
    PATH = "PATH"
    QUERY = "QUERY"

    def visit(
        self,
        body: typing.Callable[[], T_Result],
        header: typing.Callable[[], T_Result],
        path: typing.Callable[[], T_Result],
        query: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is HttpRequestPart.BODY:
            return body()
        if self is HttpRequestPart.HEADER:
            return header()
        if self is HttpRequestPart.PATH:
            return path()
        if self is HttpRequestPart.QUERY:
            return query()
