# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .annotations import Annotations
from .e_tag import ETag
from .labels import Labels
from .resource_id import ResourceId
from .resource_kind import ResourceKind
from .revision import Revision
from .timestamp import Timestamp

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Resource(pydantic.BaseModel):
    """
    Some additional comments on the fields
    kind:
    resource kind.
    createdAt:
    the time of the creation of the object (the first revision)
    updatedAt:
    the time of the creation of the _latest revision_ of the object
    deletedAt:
    the time of the deletion of the object - [soft deletion](https://en.wiktionary.org/wiki/soft_deletion)
    labels:
    used-defined key-value labels, similar to Kubernetes Labels.
    annotations:
    used-defined key-value annotations, similar to Kubernetes Annotations.
    etag:
    [Zalando RESTful Guidelines / Appendix C: Best practices / ETags in result entities](https://opensource.zalando.com/restful-api-guidelines/#ETag-in-result-entities)
    Other properties defined inside specific resource.
    """

    kind: ResourceKind
    id: ResourceId
    revision: Revision
    created_at: Timestamp
    modified_at: Timestamp
    labels: Labels
    annotations: Annotations
    etag: ETag
    deleted_at: typing.Optional[Timestamp] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
